unit MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, ImgList, ComCtrls, ToolWin, TB97Ctls, TB97, TB97Tlbr,
  RBContactsTable, ExtCtrls, RBCTButtonsBar;

type

  TContact = class
  public
    FirstName : string;
    LastName : string;
    Phone : string;
    Fax : string;
    EMail : string;
    Address1 : string;
    Address2 : string;
    Cellular : string;
  end;


  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MainImageList: TImageList;
    MainActionList: TActionList;
    FileMenu: TMenuItem;
    ContactsMenu: TMenuItem;
    N1: TMenuItem;
    ExitMI: TMenuItem;
    NewContactAction: TAction;
    EditContactAction: TAction;
    DeleteContactAction: TAction;
    StatusBar: TStatusBar;
    NewContactMI: TMenuItem;
    EditContactMI: TMenuItem;
    DeleteContactMI: TMenuItem;
    TopDock: TDock97;
    BottomDock: TDock97;
    LeftDock: TDock97;
    RightDock: TDock97;
    MainToolbar: TToolbar97;
    ToolbarButton971: TToolbarButton97;
    Table: TRBContactsTable;
    MainPopupMenu: TPopupMenu;
    NewContactPMI: TMenuItem;
    DeleteContactPMI: TMenuItem;
    N2: TMenuItem;
    EditContactPMI: TMenuItem;
    SaveAction: TAction;
    OpenAction: TAction;
    OpenMI: TMenuItem;
    SaveMI: TMenuItem;
    ToolbarSep971: TToolbarSep97;
    OpenToolbarButton: TToolbarButton97;
    SaveToolbarButton: TToolbarButton97;
    NewContactToolbarButton: TToolbarButton97;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    HelpMenu: TMenuItem;
    AboutMI: TMenuItem;
    AboutAction: TAction;
    ToolbarSep972: TToolbarSep97;
    AboutToolbarButton: TToolbarButton97;
    DisplayMenu: TMenuItem;
    LeftToRightMI: TMenuItem;
    RightToLeftMI: TMenuItem;
    N3: TMenuItem;
    CustomDrawingMI: TMenuItem;
    N4: TMenuItem;
    SortedMI: TMenuItem;
    RBCTButtonsBar: TRBCTButtonsBar;
    N5: TMenuItem;
    ItemHintsMI: TMenuItem;
    procedure ExitMIClick(Sender: TObject);
    procedure EditContactActionUpdate(Sender: TObject);
    procedure DeleteContactActionUpdate(Sender: TObject);
    procedure DeleteContactActionExecute(Sender: TObject);
    procedure NewContactActionExecute(Sender: TObject);
    procedure TableDblClick(Sender: TObject);
    procedure EditContactActionExecute(Sender: TObject);
    procedure SaveActionUpdate(Sender: TObject);
    procedure SaveActionExecute(Sender: TObject);
    procedure OpenActionExecute(Sender: TObject);
    procedure LeftToRightMIClick(Sender: TObject);
    procedure RightToLeftMIClick(Sender: TObject);
    procedure TableDrawItem(Sender: TObject; Canvas: TCanvas;
      Item: TRBContactsTableItem; Rect: TRect);
    procedure CustomDrawingMIClick(Sender: TObject);
    procedure TableItemHeight(Sender: TObject; Item: TRBContactsTableItem;
      var ItemHeight: Integer);
    procedure AboutActionExecute(Sender: TObject);
    procedure SortedMIClick(Sender: TObject);
    procedure TableDeletion(Sender: TObject; Item: TRBContactsTableItem);
    procedure TableEditedSubItem(Sender: TObject;
      Item: TRBContactsTableItem; SubItem: Integer; var NewText: String);
    procedure TableItemHint(Sender: TObject; Item: TRBContactsTableItem;
      var ItemHint: String; var MaxWidth: Integer; var ShowHint: Boolean);
    procedure ItemHintsMIClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure UpdateItem ( Item : TRBContactsTableItem );
  end;

var
  MainForm: TMainForm;

implementation

uses ContactFormUnit, AboutFormUnit;

{$R *.DFM}

procedure TMainForm.ExitMIClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditContactActionUpdate(Sender: TObject);
begin
  if Table.Selected = nil then EditContactAction.Enabled := False
  else EditContactAction.Enabled := True;
end;

procedure TMainForm.DeleteContactActionUpdate(Sender: TObject);
begin
  if Table.Selected = nil then DeleteContactAction.Enabled := False
  else DeleteContactAction.Enabled := True;
end;

procedure TMainForm.DeleteContactActionExecute(Sender: TObject);
begin
  Table.Selected.Delete;
end;

procedure TMainForm.NewContactActionExecute(Sender: TObject);
var
  contact : TContact;
  item : TRBContactsTableItem;
begin
  ContactForm.NewContact := True;
  contact := TContact.Create;
  ContactForm.Contact := contact;
  if ContactForm.ShowModal = mrOk then
  begin
    ContactForm.UpdateToContact;
    Table.Items.BeginUpdate;
    item := Table.Items.AddObject ( contact.LastName + ', ' + contact.FirstName ,
                                    contact );
    UpdateItem ( item );
    Table.Items.EndUpdate;
  end
  else
    contact.Free;
end;

procedure TMainForm.TableDblClick(Sender: TObject);
begin
  if Table.Selected = nil then NewContactAction.Execute
  else EditContactAction.Execute;
end;

procedure TMainForm.UpdateItem(Item: TRBContactsTableItem);
var
  contact : TContact;
begin
  Table.Items.BeginUpdate;
  Item.SubItems.Clear;
  contact := Item.Data;
  with contact do
  begin
    if Address1 <> '' then Item.SubItems.Add ( Address1 );
    if Address2 <> '' then Item.SubItems.Add ( Address2 );
    if Phone <> '' then Item.SubItems.Values['Phone:'] := Phone;
    if Cellular <> '' then Item.SubItems.Values['Cellular:'] := Cellular;
    if Fax <> '' then Item.SubItems.Values['Fax:'] := Fax;
    if EMail <> '' then Item.SubItems.Values['E-Mail:'] := EMail;
  end;
  Table.Items.EndUpdate;
end;

procedure TMainForm.EditContactActionExecute(Sender: TObject);
var
  contact : TContact;
begin
  ContactForm.NewContact := False;
  contact := Table.Selected.Data;
  ContactForm.Contact := contact;
  ContactForm.UpdateFromContact;
  if ContactForm.ShowModal = mrOk then
  begin
    ContactForm.UpdateToContact;
    Table.Items.BeginUpdate;
    Table.Selected.Text := contact.LastName + ', ' + contact.FirstName;
    UpdateItem ( Table.Selected );
    Table.Items.EndUpdate;
  end
end;

procedure TMainForm.SaveActionUpdate(Sender: TObject);
begin
  if Table.Items.Count = 0 then SaveAction.Enabled := False
  else SaveAction.Enabled := True;
end;

procedure TMainForm.SaveActionExecute(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    Table.SaveToFile ( SaveDialog.FileName );
  end;
end;

procedure TMainForm.OpenActionExecute(Sender: TObject);
var
  i : integer;
  contact : TContact;
  item : TRBContactsTableItem;
  s : string;
begin
  if not OpenDialog.Execute then Exit;

  Table.LoadFromFile ( OpenDialog.FileName );
  for i := 0 to Table.Items.Count-1 do
  begin
    item := Table.Items[i];
    contact := TContact.Create;

    item.Data := contact;
    s := Item.Text;

    contact.LastName := Copy ( s , 1 , Pos ( ',' , s )-1);
    contact.FirstName := Copy ( s , Length ( contact.LastName)+3 , 255 );
    contact.Phone := item.SubItems.Values['Phone:'];
    contact.Fax := item.SubItems.Values['Fax:'];
    contact.EMail := item.SubItems.Values['E-Mail:'];
    contact.Cellular := item.SubItems.Values['Cellular:'];

    if ( item.SubItems.Count >= 1 ) and
       ( Pos ( ':' , item.SubItems[0] ) = 0 ) then
       contact.Address1 := item.SubItems[0];
    if ( item.SubItems.Count >= 2 ) and
       ( Pos ( ':' , item.SubItems[1] ) = 0 ) then
       contact.Address2 := item.SubItems[1];
  end;
end;

procedure TMainForm.LeftToRightMIClick(Sender: TObject);
begin
  RightToLeftMI.Checked := False;
  LeftToRightMI.Checked := True;
  Table.BiDiMode := bdLeftToRight;
end;

procedure TMainForm.RightToLeftMIClick(Sender: TObject);
begin
  RightToLeftMI.Checked := True;
  LeftToRightMI.Checked := False;
  Table.BiDiMode := bdRightToLeft;  
end;

procedure TMainForm.TableDrawItem(Sender: TObject; Canvas: TCanvas;
  Item: TRBContactsTableItem; Rect: TRect);
var
  contact : TContact;
  points : array [0..4] of TPoint;
  region : HRgn;
  r : TRect;
begin
  contact := Item.Data;
  region := CreateRectRgn ( Rect.Left , Rect.Top , Rect.Right , Rect.Bottom );
  SelectClipRgn ( Canvas.Handle , region );
  with Canvas, contact do
  begin
    Pen.Color := clBlack;
    Pen.Style := psSolid;
    if Item.Selected then Brush.Color := clOlive
    else Brush.Color := clYellow;
    Brush.Style := bsSolid;
    points[0] := Point ( Rect.Left , Rect.Top );
    points[1] := Point ( Rect.Left , Rect.Bottom-1 );
    points[2] := Point ( Rect.Right-1 , Rect.Bottom-1 );
    points[3] := Point ( Rect.Right-1 , Rect.Top+10 );
    points[4] := Point ( Rect.Right-11 , Rect.Top );
    Polygon ( points );

    points[0] := Point ( Rect.Right-1 , Rect.Top+10 );
    points[1] := Point ( Rect.Right-11 , Rect.Top );
    points[2] := Point ( Rect.Right-11 , Rect.Top+10 );
    Polygon ( Slice ( points , 3 ) );

    Font.Color := clBlack;
    Font.Name := 'Arial';
    Font.Size := 14;

    r.Left := Rect.Left + 5;
    r.Top := Rect.Top + 5;
    r.Right := Rect.Right - 15;
    r.Bottom := Rect.Bottom;

    DrawText ( Handle , PChar(Item.Text) , Length ( Item.Text) , r ,
               DT_END_ELLIPSIS );

    MainImageList.Draw ( Canvas , Rect.Left+5 , Rect.Top+30 , 5 );

    Font.Size := 8;
    r.Left := Rect.Left + 24;
    r.Top := Rect.Top + 30;
    r.Right := Rect.Right - 15;
    r.Bottom := Rect.Bottom;

    DrawText ( Handle , PChar(contact.Phone) , Length ( contact.Phone ) , r ,
               DT_END_ELLIPSIS );

    MainImageList.Draw ( Canvas , Rect.Left+5 , Rect.Top+48 , 6 );

    r.Left := Rect.Left + 24;
    r.Top := Rect.Top + 48;
    r.Right := Rect.Right - 15;
    r.Bottom := Rect.Bottom;

    DrawText ( Handle , PChar(contact.EMail) , Length ( contact.EMail ) , r ,
               DT_END_ELLIPSIS );

  end;
  SelectClipRgn ( Canvas.Handle , 0 );
end;

procedure TMainForm.CustomDrawingMIClick(Sender: TObject);
begin
  CustomDrawingMI.Checked := not CustomDrawingMI.Checked;
  Table.CustomDrawing := CustomDrawingMI.Checked;
  Table.ReadOnly := Table.CustomDrawing;
end;

procedure TMainForm.TableItemHeight(Sender: TObject;
  Item: TRBContactsTableItem; var ItemHeight: Integer);
begin
  ItemHeight := 70;
end;

procedure TMainForm.AboutActionExecute(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.SortedMIClick(Sender: TObject);
begin
  SortedMI.Checked := not SortedMI.Checked;
  Table.Sorted := SortedMI.Checked;
end;

procedure TMainForm.TableDeletion(Sender: TObject;
  Item: TRBContactsTableItem);
begin
  TContact(Item.Data).Free;
end;

procedure TMainForm.TableEditedSubItem(Sender: TObject;
  Item: TRBContactsTableItem; SubItem: Integer; var NewText: String);
var
  contact_item : TContact;
begin
  contact_item := Item.Data;
  if NewText = '' then NewText := 'none';

  if item.SubItems.Names[SubItem] = 'Phone:' then
    contact_item.Phone := NewText
  else if item.SubItems.Names[SubItem] = 'Fax:' then
    contact_item.Fax := NewText
  else if item.SubItems.Names[SubItem] = 'E-Mail:' then
    contact_item.EMail := NewText
  else if item.SubItems.Names[SubItem] = 'Cellular:' then
    contact_item.Cellular := NewText
  else
  begin
    if SubItem = 0 then contact_item.Address1 := NewText
    else contact_item.Address2 := NewText;
  end;

end;

procedure TMainForm.TableItemHint(Sender: TObject;
  Item: TRBContactsTableItem; var ItemHint: String; var MaxWidth: Integer;
  var ShowHint: Boolean);
var
  contact_item : TContact;
begin
  contact_item := Item.Data;
  ItemHint := contact_item.FirstName + ' ' + contact_item.LastName;
end;

procedure TMainForm.ItemHintsMIClick(Sender: TObject);
begin
  ItemHintsMI.Checked := not ItemHintsMI.Checked;
  Table.ItemsHints := ItemHintsMI.Checked;
end;

end.
